"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var debounce = function debounce(func, wait, immediate) {
  var timeout = undefined;
  return function () {
    var context = this,
        args = arguments; // eslint-disable-line no-undef
    var later = function later() {
      timeout = null;
      if (!immediate) func.apply(context, args);
    };
    var callNow = immediate && !timeout;
    clearTimeout(timeout);
    timeout = setTimeout(later, wait);
    if (callNow) func.apply(context, args);
  };
};

exports.debounce = debounce;